# copyright= 'Huynh Duong Phuong Vi @ 2014'
# suforyou.vn@gmail.com
#require 'langhandler.rb'
#$s4u_scaletoolStrings = LanguageHandler.new("s4u_scaletool.strings")
module S4U
module S4u_ScaleTool
  def self.scale(element,x,y,z)
        t=Geom::Transformation.new([x,0,0,0,0,y,0,0,0,0,z,0,0,0,0,1])
        element.transformation = element.transformation*t
  end
  def self.setscale(element)   
        t=element.transformation
        sc=Geom::Transformation.new([1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1])
       	t1=Geom::Transformation.new(t.xaxis,t.yaxis,t.zaxis,t.origin)
      	element.transformation = sc
	element.transformation = t1
  end  
  def self.resetscale()
	model =Sketchup.active_model
	model.start_operation "resetscale"
	sel=[]
	select =model.selection 
    	if select.length==0 
             	Sketchup.set_status_text $s4u_scaletoolStrings.GetString("No selected element")
		UI.messagebox $s4u_scaletoolStrings.GetString("Select groups or components")
        	return
    	else
       		 select.each{|s| sel.push s}
    	end
    	objects=[]               
        	sel.each{|e|   objects.push e if e.is_a?Sketchup::Group or e.is_a?Sketchup::ComponentInstance    } 
    	if objects.length==0 
         	Sketchup.set_status_text $s4u_scaletoolStrings.GetString("No selected element")
                UI.messagebox $s4u_scaletoolStrings.GetString("Select groups or components")
        	return
    	else
         	Sketchup.set_status_text $s4u_scaletoolStrings.GetString(objects.length.to_s + " selected elements")
    	end	    	
        	objects.each{|obj|  self.setscale(obj)  }
	model.commit_operation
  end
  def self.scaletool(flag)
       	model =Sketchup.active_model
        model.start_operation "scaletool"
        sel=[]
       	select =model.selection 
    	if select.length==0 
            	Sketchup.set_status_text $s4u_scaletoolStrings.GetString("No selected element")
            	UI.messagebox $s4u_scaletoolStrings.GetString("Select groups or components")
            	return
    	else
                select.each{|s| sel.push s}
    	end
    		objects=[] 
      		if flag==1       			
                         prompts = [$s4u_scaletoolStrings.GetString("Axis?"),$s4u_scaletoolStrings.GetString("Dimension or Ratio?"),$s4u_scaletoolStrings.GetString("Value?")]
                         list = ["x|y|z","Dimension|Ratio",""]
             		 defaults = ["z","Dimension","10"]        
              		 input = UI.inputbox(prompts,defaults,list,$s4u_scaletoolStrings.GetString("Enter dimension or ratio"))        
             		 if input
                               axis=input[0].to_s
                 		modescale=input[1].to_s
                    		value=input[2].to_f
                                return if value==0
                         else
                                return
                         end
		     else
                     	prompts = [$s4u_scaletoolStrings.GetString("Axis?"),$s4u_scaletoolStrings.GetString("Dimension?")]
             		 list = ["x|y|z",""]
                     	defaults = ["z","10"]        
                     	input = UI.inputbox(prompts,defaults,list,$s4u_scaletoolStrings.GetString("Enter fixed Dimension"))        
            		if input       
                            	axis=input[0].to_s
                		value=Sketchup.parse_length input[1]
                     	else
                       		 return  
                  	end
             	end
        	sel.each{|e| objects.push e if e.is_a?Sketchup::Group or e.is_a?Sketchup::ComponentInstance} 
    			if objects.length==0 
         	 		Sketchup.set_status_text $s4u_scaletoolStrings.GetString("No selected element")
                		UI.messagebox $s4u_scaletoolStrings.GetString("Select groups or components")
        	 		return
    			else
         	 	Sketchup.set_status_text $s4u_scaletoolStrings.GetString(objects.length.to_s + " selected elements")
    	end	 
     case axis
        when "x" 
            objects.each{|obj|  
        		t=obj.transformation                  		
        		group1=model.active_entities.add_group obj   	
        		neworigin=Geom::Point3d.new t.origin.x,t.origin.y,t.origin.z
        		t1=Geom::Transformation.new(t.xaxis,t.yaxis,t.zaxis,neworigin)
        		group1.transformation=t1                                               
                      obj.transformation= t1.inverse*t 
                      d=obj.bounds.width                                        
                      tg1=group1.transformation
                      vector=[obj.bounds.corner(0).x,0,0]
                      vector.transform! t1
                      po=obj.transformation.origin.transform Geom::Transformation.new vector                      
                      group2=model.active_entities.add_group group1
                      group2.transformation=Geom::Transformation.new(tg1.xaxis,tg1.yaxis,tg1.zaxis,po)
                   	  group1.transformation=group2.transformation.inverse*tg1                       
                if flag==1 
                       if modescale == "Dimension"
            				s=Sketchup.parse_length value.to_s
	            			sx=1+(s/ d)  if d!=0                   
            				self.scale(group2,sx,1,1) if sx!=0
		               else      
            				self.scale(group2,value,1,1)
                       end    
                else                       
                  		if d!=0
			                 s= value / d
		                     self.scale(group2,s,1,1)  
                    	end        		              		
                end
                group1.explode 
                group2.explode 
        	}    
        when "y" 
            objects.each{|obj|  
        		t=obj.transformation                  		
        		group1=model.active_entities.add_group obj   	
        		neworigin=Geom::Point3d.new t.origin.x,t.origin.y,t.origin.z
        		t1=Geom::Transformation.new(t.xaxis,t.yaxis,t.zaxis,neworigin)
        		group1.transformation=t1                                               
                      obj.transformation= t1.inverse*t 
                      d=obj.bounds.height                                        
                      tg1=group1.transformation
                      vector=[0,obj.bounds.corner(4).y,0]
                      vector.transform! t1
                      po=obj.transformation.origin.transform Geom::Transformation.new vector                      
                      group2=model.active_entities.add_group group1
                      group2.transformation=Geom::Transformation.new(tg1.xaxis,tg1.yaxis,tg1.zaxis,po)
                   	  group1.transformation=group2.transformation.inverse*tg1                       
                if flag==1 
                       if modescale == "Dimension"
            				s=Sketchup.parse_length value.to_s
	            			sy=1+(s/ d)  if d!=0                   
            				self.scale(group2,1,sy,1) if sy!=0
		               else      
            				self.scale(group2,1,value,1)
                       end    
                else                       
                  		if d!=0
			                 s= value / d
		                     self.scale(group2,1,s,1)  
                    	end        		              		
                end
                group1.explode 
                group2.explode 
        	}  
        else
            objects.each{|obj|  
        		t=obj.transformation                  		
        		group1=model.active_entities.add_group obj   	
        		neworigin=Geom::Point3d.new t.origin.x,t.origin.y,t.origin.z
        		t1=Geom::Transformation.new(t.xaxis,t.yaxis,t.zaxis,neworigin)
        		group1.transformation=t1                                               
                      obj.transformation= t1.inverse*t 
                      d=obj.bounds.depth                                        
                      tg1=group1.transformation
                      vector=[0,0,obj.bounds.min.z]
                      vector.transform! t1
                      po=obj.transformation.origin.transform Geom::Transformation.new vector                      
                      group2=model.active_entities.add_group group1
                      group2.transformation=Geom::Transformation.new(tg1.xaxis,tg1.yaxis,tg1.zaxis,po)
                   	  group1.transformation=group2.transformation.inverse*tg1                      
                if flag==1 
                       if modescale == "Dimension"
            				s=Sketchup.parse_length value.to_s
	            			sz=1+(s/ d)  if d!=0                   
            				self.scale(group2,1,1,sz) if sz!=0
		               else      
            				self.scale(group2,1,1,value)
                       end    
                else                       
                  		if d!=0
			                 s= value / d
		                     self.scale(group2,1,1,s)  
                    	end        		              		
                end
                group1.explode 
                group2.explode 
        	}       
    end      	
    model.commit_operation
    end
end
end
#S4U::S4u_ScaleTool.scaletool(0)
#S4U::S4u_ScaleTool.scalefix
#S4U::S4u_ScaleTool.resetscale
